package com.incubator.game.handler.address;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.incubator.common.MessageHandler;
import com.incubator.common.net.Connection;
import com.incubator.core.net.ws.NetHandler;
import com.incubator.core.net.ws.WSRequest;
import com.incubator.core.net.ws.WSResponse;
import com.incubator.game.constant.RedisKeyConstant;
import com.incubator.game.data.jedis.RedisUtil;
import com.incubator.game.data.po.ZjMemberAddrPO;
import com.incubator.game.util.UtilCore;
import com.incubator.message.proto.CommonProto;

import java.util.*;

/**
 * Author:  xhb
 * Date:  2024-12-10 15:07
 */
@MessageHandler(id = CommonProto.Cmd.GetAddressListReq_VALUE)
public class GetAddressList extends NetHandler {

    @Override
    public void onDate(Connection session, WSRequest request, WSResponse response) {
        response.setCmd(CommonProto.Cmd.GetAddressListRes_VALUE);

        String userId = request.getDataValue("userId", String.class, "");
        String userInfo = RedisUtil.get(RedisKeyConstant.USER_BASE + userId);
        JSONObject userObject = JSONUtil.parseObj(userInfo);
        JSONArray userAddress = userObject.getJSONArray("userAddress");
        List<ZjMemberAddrPO> zjMemberAddrPOList = userAddress.toList(ZjMemberAddrPO.class);
        Map<String,Object> map = new HashMap<>();
        map.put("addressList",zjMemberAddrPOList);
        response.setData(map);
    }
}
