package com.incubator.game.handler.address;

import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.incubator.common.MessageHandler;
import com.incubator.common.net.Connection;
import com.incubator.core.net.ws.NetHandler;
import com.incubator.core.net.ws.WSRequest;
import com.incubator.core.net.ws.WSResponse;
import com.incubator.game.constant.RedisKeyConstant;
import com.incubator.game.data.jedis.RedisUtil;
import com.incubator.game.data.po.ZjMemberAddrPO;
import com.incubator.message.proto.CommonProto;

import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;


/**
 * Author:  xhb
 * Date:  2024-12-10 15:06
 */
@MessageHandler(id = CommonProto.Cmd.SaveAddressReq_VALUE)
public class SaveAddress extends NetHandler {

    @Override
    public void onDate(Connection session, WSRequest request, WSResponse response) {
        response.setCmd(CommonProto.Cmd.SaveAddressRes_VALUE);
        String addressInfo = request.getDataValue("addressInfo", String.class, "");
        JSONObject addressObject = JSONUtil.parseObj(addressInfo);
        ZjMemberAddrPO zjMemberAddrPO = addressObject.toBean(ZjMemberAddrPO.class);

        String userInfo = RedisUtil.get(RedisKeyConstant.USER_BASE + zjMemberAddrPO.getUserId());
        JSONObject userObject = JSONUtil.parseObj(userInfo);
        JSONArray userAddress = userObject.getJSONArray("userAddress");
        List<ZjMemberAddrPO> zjMemberAddrPOList = userAddress.toList(ZjMemberAddrPO.class);
        zjMemberAddrPOList.add(zjMemberAddrPO);

        if (zjMemberAddrPO.getCommonAddr()==1){
            zjMemberAddrPOList.stream()
                    .peek(po -> po.setStatus(Objects.equals(po.getAddrId(), zjMemberAddrPO.getAddrId()) ? 1 : 0))
                    .collect(Collectors.toList());
        }
        RedisUtil.set(RedisKeyConstant.USER_BASE + zjMemberAddrPO.getUserId(), userObject.toString());
        response.setMessage("操作成功！");
    }
}
