package com.incubator.game.handler.club;

import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.incubator.common.MessageHandler;
import com.incubator.common.net.Connection;
import com.incubator.core.net.ws.NetHandler;
import com.incubator.core.net.ws.WSRequest;
import com.incubator.core.net.ws.WSResponse;
import com.incubator.game.constant.RedisKeyConstant;
import com.incubator.game.data.jedis.RedisUtil;
import com.incubator.game.data.po.ZjClubMemberPo;
import com.incubator.game.data.po.ZjUserLobbyPo;
import com.incubator.game.util.UtilCore;
import com.incubator.message.proto.CommonProto;


/**
 * Author:  xhb
 * Date:  2024-12-09 14:27
 * 请求加入俱乐部请求
 */
@MessageHandler(id = CommonProto.Cmd.ApplyJoinClubReq_VALUE)
public class ApplyJoinClub extends NetHandler {

    @Override
    public void onDate(Connection session, WSRequest request, WSResponse response) {
        response.setCmd(CommonProto.Cmd.ApplyJoinClubRes_VALUE);
        /**
         *memberId,userId,clubId,memberStatus,requestExplain,requestChannel
         */
        String clubMemberInfo = request.getDataValue("clubMemberInfo", String.class, "");
        ZjClubMemberPo newClubMember = JSONUtil.parseObj(clubMemberInfo).toBean(ZjClubMemberPo.class);
        String userInfo = RedisUtil.get(RedisKeyConstant.USER_BASE + newClubMember.getUserId());
        JSONObject userObject = JSONUtil.parseObj(userInfo);
        Object lobbyUserObj = userObject.get("lobbyUser");
        ZjUserLobbyPo lobbyUser = JSONUtil.toBean((JSONObject) lobbyUserObj, ZjUserLobbyPo.class);

        //创建成员信息
        newClubMember.setMemberId(UtilCore.getDateRandomId());
        newClubMember.setMemberStatus("0");//加入状态 0:申请加入 1:同意加入 2:拒绝加入 3:退出俱乐部 4:删除俱乐部
        newClubMember.setNickName(lobbyUser.getNickName());
        newClubMember.setAvatarUrl(lobbyUser.getAvatarUrl());
        newClubMember.setWinRate(lobbyUser.getTraditionChance());
        String memBerList = RedisUtil.get(RedisKeyConstant.CLUB_MEMBER + newClubMember.getClubId());
        JSONArray clubMember = JSONUtil.parseObj(memBerList).getJSONArray("clubMember");
        clubMember.add(newClubMember);
        JSONObject object = new JSONObject();
        object.put("clubMember", clubMember);
        RedisUtil.set(RedisKeyConstant.CLUB_MEMBER + newClubMember.getClubId(), object.toString());
        response.setMessage("申请成功！");
    }
}
