package com.incubator.game.handler.club;

import cn.hutool.json.JSONArray;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.incubator.common.MessageHandler;
import com.incubator.common.net.Connection;
import com.incubator.core.net.ws.NetHandler;
import com.incubator.core.net.ws.WSRequest;
import com.incubator.core.net.ws.WSResponse;
import com.incubator.game.constant.RedisKeyConstant;
import com.incubator.game.data.jedis.RedisUtil;
import com.incubator.game.data.po.ZjClubPo;
import com.incubator.message.proto.CommonProto;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.stream.Collectors;

/**
 * Author:  xhb
 * Date:  2024-12-10 14:14
 * 获取我的俱乐部列表消息
 */
@MessageHandler(id = CommonProto.Cmd.GetMyClubListReq_VALUE)
public class GetMyClubList extends NetHandler {

    @Override
    public void onDate(Connection session, WSRequest request, WSResponse response) {
        response.setCmd(CommonProto.Cmd.GetMyClubListRes_VALUE);

        String userId = request.getDataValue("userId", String.class, "");
        String userInfo = RedisUtil.get(RedisKeyConstant.USER_BASE + userId);
        JSONObject jsonObject = JSONUtil.parseObj(userInfo);
        JSONArray clubListArray = JSONUtil.parseObj(jsonObject).getJSONArray("clubList");
        List<ZjClubPo> clubList = clubListArray.toList(ZjClubPo.class);

        List<ZjClubPo> collect = clubList.stream()
                .filter(club -> club.getClubStatus().equals("1"))
                .collect(Collectors.toList());

        Map<String,Object> hashMap = new HashMap<>();
        hashMap.put("clubList", collect);
        response.setData(hashMap);
    }
}
